Package org.spongepowered.asm.obfuscation

## Class RemapperChain

- java.lang.Object
- - org.spongepowered.asm.obfuscation.RemapperChain

All Implemented Interfaces:
  `IRemapper`

    public class RemapperChain
    extends java.lang.Object
    implements IRemapper

Mixin environment remapper chain. Contains all remappers for the current environment to facilitate remapping via all registered remappers.

### Constructor Summary

Constructors
`RemapperChain()`

### Method Summary

All Methods Instance Methods Concrete Methods
`RemapperChain` `add​(IRemapper remapper)` Add a new remapper to this chain
`java.lang.String` `map​(java.lang.String typeName)` Map type name to the new name.
`java.lang.String` `mapDesc​(java.lang.String desc)` Convert a descriptor to remapped form
`java.lang.String` `mapFieldName​(java.lang.String owner, java.lang.String name, java.lang.String desc)` Map field name to the new name.
`java.lang.String` `mapMethodName​(java.lang.String owner, java.lang.String name, java.lang.String desc)` Map method name to the new name.
`java.lang.String` `toString()`
`java.lang.String` `unmap​(java.lang.String typeName)` Convert a mapped type name back to the original obfuscated name
`java.lang.String` `unmapDesc​(java.lang.String desc)` Convert a descriptor back to the original obfuscated form

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### RemapperChain

    public RemapperChain()

### Method Detail

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### add

    public RemapperChain add​(IRemapper remapper)

Add a new remapper to this chain

Parameters:
  `remapper` - remapper to add
Returns:
  fluent interface

#### mapMethodName

    public java.lang.String mapMethodName​(java.lang.String owner,
                                          java.lang.String name,
                                          java.lang.String desc)

Description copied from interface: `IRemapper`
Map method name to the new name. Subclasses can override.

Specified by:
  `mapMethodName` in interface `IRemapper`
Parameters:
  `owner` - owner of the method.
  `name` - name of the method.
  `desc` - descriptor of the method.
Returns:
  new name of the method

#### mapFieldName

    public java.lang.String mapFieldName​(java.lang.String owner,
                                         java.lang.String name,
                                         java.lang.String desc)

Description copied from interface: `IRemapper`
Map field name to the new name. Subclasses can override.

Specified by:
  `mapFieldName` in interface `IRemapper`
Parameters:
  `owner` - owner of the field.
  `name` - name of the field
  `desc` - descriptor of the field
Returns:
  new name of the field.

#### map

    public java.lang.String map​(java.lang.String typeName)

Description copied from interface: `IRemapper`
Map type name to the new name. Subclasses can override.

Specified by:
  `map` in interface `IRemapper`
Parameters:
  `typeName` - Class name to convert
Returns:
  new name for the class

#### unmap

    public java.lang.String unmap​(java.lang.String typeName)

Description copied from interface: `IRemapper`
Convert a mapped type name back to the original obfuscated name

Specified by:
  `unmap` in interface `IRemapper`
Parameters:
  `typeName` - Class name to convert
Returns:
  old name for the class

#### mapDesc

    public java.lang.String mapDesc​(java.lang.String desc)

Description copied from interface: `IRemapper`
Convert a descriptor to remapped form

Specified by:
  `mapDesc` in interface `IRemapper`
Parameters:
  `desc` - descriptor to convert
Returns:
  new descriptor

#### unmapDesc

    public java.lang.String unmapDesc​(java.lang.String desc)

Description copied from interface: `IRemapper`
Convert a descriptor back to the original obfuscated form

Specified by:
  `unmapDesc` in interface `IRemapper`
Parameters:
  `desc` - descriptor to convert
Returns:
  old descriptor